function GoogleCalendar(url, useJson, jsonElementId) {
  this.type = "Google Calendar Feed";
  this.title = "Google Calendar";
  this.time = null;
  this.repeat = 0;
  this.calUrl = url;
  this.useJson = useJson;
  this.jsonElementId = jsonElementId;
    
  
  this.requestCalendar = function() {
    if (this.useJson) {
      GoogleCalendar.objects[this.jsonElementId] = this;
      eval("GoogleCalendar." + this.jsonElementId + 
           "=function(root) {GoogleCalendar.objects['" +
           this.jsonElementId + "'].jsonCallback(root)}");
      GoogleCalendar.requestCalendarJson(this.calUrl, $(this.jsonElementId), 
        "GoogleCalendar." + this.jsonElementId);  
    }
    else {
      this.requestCalendarAjax();
    }
  }
  
  this.jsonCallback = function(root) {
    var result = GoogleCalendar.parseCalendarJson(root);
    this.parseResult(result);    
  }
    
  this.requestCalendarAjax = function() {  
    var request = new XMLHttpRequest();
    request._self = this;
    var url = this.calUrl;
    var index = url.indexOf("http");
    if (index >= 0) {
      //Full public URL
      var start = url.indexOf("feeds/");
      if (start >= 0) {
        var end = url.indexOf("/", start + 6);
        if (end >= 0) {
          url = url.substring(start + 6, end);
        }
      }
    }
    var index = this.calUrl.lastIndexOf("/");
    if (index > 0) {
      this.calUrl = this.calUrl.substring(0, index) + "/full";
    }
    request.overrideMimeType("text/xml");
    request.open("GET", this.calUrl + "?orderby=starttime&max-results=5&singleevents=true&sortorder=ascending&futureevents=true", true);
    request.onreadystatechange = function () {
      if (request.readyState == 4) {
        if (request.status == 200) {
          var root = request.responseXML;
          var result = GoogleCalendar.parseCalendarXml(root);
          request._self.parseResult(result);
        }
        else {
          if (request._self.onerror) {
            request._self.onerror();
          }
        }
      }
    }
    request.send(null);
  }
  
  this.parseResult = function(result) {
    if (result.icon) {
      this.icon = result.icon;
    }
    else {
      this.icon = null;
    }
    this.type = result.type;
    this.title = result.title;
    this.time = result.time;
    if (result.url) {
      this.url = result.url;
    }
    else {
      this.url = null;
    }  
    if (this.onload) {
      this.onload();
    }    
  }
  
  this.onload = null;
 
  this.onerror = null;
  
  this.setTitle = function(title) {
    this.title = title;
  }
  
  this.getTime = function() {
    return this.time;
  }
  
  this.setTime = function(time) {
    this.time = time;
  }
  
  this.setRepeat = function(repeat) {
    this.repeat = repeat;
  }
  
  this.hasNextTime = function() {
    return true;
  }
  
  this.nextTime = function() {
    this.requestCalendar();
  }
}

GoogleCalendar.parseCalendarXml = function(root) {
  var result = new Object();
  var feed = root.getElementsByTagName("feed")[0];
  var titles = feed.getElementsByTagName("title");
  if (titles != null && titles.length > 0) {
    result.type = feed.getElementsByTagName("title")[0].firstChild.data;
  }
  else {
    result.type = "Calendar";
    //Safari fix
    for (var i = 0; i < feed.childNodes.length; i++) {
 	    if (feed.childNodes[i].nodeName == "title") {
        result.type = feed.childNodes[i].firstChild.data;
        break;
 	    }
    }
  }           
  var entries = feed.getElementsByTagName("entry");
  if (entries.length == 0) {
    result.time = null;
    result.title = "No Event";
    return result;
  }
  var index = 0;
  var nextEntry = null;
  var now = new Date();
  do {
    var entry = entries[index];
    var when = entry.getElementsByTagName("when")[0];
    var date = when.getAttribute("startTime");
    var time = GoogleCalendar.parseDate(date)
    if (time >now && (!nextEntry || nextEntry.time > time)) {
      nextEntry = entry;
      nextEntry.time = time;
    }
    index++;
  }
  while (time < new Date() && index < entries.length);
  if (!nextEntry) {
    result.time = null;
    result.title = "No future Events";
    return result;
  }
  result.time = nextEntry.time;
  var titles = nextEntry.getElementsByTagName("title");
  if (titles != null && titles.length > 0) {
    result.title = nextEntry.getElementsByTagName("title")[0].firstChild.data;
  }
  else {
    result.title = "Calendar Event";
    //Safari fix
    for (var i = 0; i < nextEntry.childNodes.length; i++) {
 	    if (nextEntry.childNodes[i].nodeName == "title") {
        result.title = nextEntry.childNodes[i].firstChild.data;
        break;
 	    }
    }
  }  
  var links = nextEntry.getElementsByTagName("link");
  if (links.length > 0) {
    for (var i = 0; i < links.length; i++) {
    	var link = links[i];
    	if (link.getAttribute("rel") == "alternate") {
        result.url = link.getAttribute("href");  	  
    	}
    	if (link.getAttribute("rel") == "http://schemas.google.com/gCal/2005/webContent") {
    	  result.icon = link.getAttribute("href");
    	}
    }
  }
  else {
    for (var i = 0; i < nextEntry.childNodes.length; i++) {
    	if (nextEntry.childNodes[i].nodeName == "link") {
    	  var link = nextEntry.childNodes[i];
    	  if (link.getAttribute("rel") == "alternate") {
          result.url = link.getAttribute("href");  	  
    	  }
    	  if (link.getAttribute("rel") == "http://schemas.google.com/gCal/2005/webContent") {
    	    result.icon = link.getAttribute("href");
    	  }
    	}
    }    
  }
  return result;
}

GoogleCalendar.parseCalendarJson = function(root) {
  var result = new Object();
  var feed = root;
  result.type = feed.summary;
  var entries = feed.items;
  if (!entries || entries.length == 0) {
    result.time = null;
    result.title = "No Events";
    return result;
  }
  var index = 0;
  var nextEntry = null;
  var now = new Date();
  do {
    var entry = entries[index];
    console.log(entry);
    var when = entry.start;
    var date = when.dateTime;
    if (!date) {
      date = when.date;
    }
    var time = GoogleCalendar.parseDate(date)
    //alert(date + " " + time);
    if (time >now && (!nextEntry || nextEntry.time > time)) {
      nextEntry = entry;
      nextEntry.time = time;
    }
    index++;
  }
  while (index < entries.length);
  if (!nextEntry) {
    result.time = null;
    result.title = "No future Events";
    return result;
  }
  result.time = nextEntry.time;
  result.title = nextEntry.summary;
  var links = []; //nextEntry.link;
  for (var i = 0; i < links.length; i++) {
    var link = links[i];
    if (link.rel == "alternate") {
      result.url = link.href;
    }
    if (link.rel == "http://schemas.google.com/gCal/2005/webContent") {
      result.icon = link.href;
    }
  }
  return result
}

GoogleCalendar.requestCalendarJson = function(url, element, callback) {
  var index = url.lastIndexOf("/");
  if (index > 0) {
    url = url.substring(0, index) + "/full";
  }
  var index = url.indexOf("http");
  if (index >= 0) {
    //Full public URL
    console.log(url);
    var start = url.indexOf("feeds/");
    console.log("Start:" + start);
    if (start >= 0) {
      var end = url.indexOf("/", start + 6);
      console.log("End:" + end);
      if (end >= 0) {
        url = url.substring(start + 6, end);
        console.log(url);
      }
    }
  }
  var script = element;
  script.innerHTML = "";
  var inside = document.createElement("script");
  var now = new Date();
  now.setDate(now.getDate() - 1);
  var text = now.getFullYear() + "-";
  var month = (now.getMonth() + 1) + "";
  if (month.length < 2) {
    month = "0" + month;
  }
  var day = now.getDate() + "";
  if (day.length < 2) {
    day = "0" + day;
  }
  text = text + month + "-" + day;
  inside.src = "https://www.googleapis.com/calendar/v3/calendars/" +
      url +
      "/events?key=AIzaSyB2NUC5GSqL2U5gyGL5Ec0gVkNdNlxx-TY&maxResults=40&orderBy=startTime&singleEvents=true" +
      "&timeMin=" + text + "T00%3A00%3A00Z&callback=" + encodeURIComponent(callback);
  //inside.src = url + "?alt=json-in-script&orderby=starttime&max-results=25&singleevents=true&sortorder=ascending&futureevents=true&callback=" + encodeURIComponent(callback);
  script.appendChild(inside);
}

GoogleCalendar.parseDate = function(date) {
  var time = new Date();
  if (!date) {
    return new Date(2000, 1, 1);
  }
  time.setUTCFullYear(parseInt(date.substring(0, 4), 10));
  time.setUTCMonth(parseInt(date.substring(5, 7), 10) - 1);
  time.setUTCDate(parseInt(date.substring(8, 10), 10));
  time.setUTCMonth(parseInt(date.substring(5, 7), 10) - 1);
  if (date.length > 11) {
    time.setUTCHours(parseInt(date.substring(11, 13), 10))
    time.setUTCMinutes(parseInt(date.substring(14, 16), 10));
  }
  else {
    time.setUTCHours(0);
    time.setUTCMinutes(time.getTimezoneOffset());
  }
  time.setUTCSeconds(0);
  time.setUTCMilliseconds(0);
  if (date.length > 24) {
    console.log(date);
    var zone = parseInt(date.substring(19, 22), 10);
    console.log(date.substring(19, 22));
    time.setUTCHours(time.getUTCHours() - zone);
  }
  else {
    //time.setUTCMinutes(time.getUTCMinutes() - time.getTimezoneOffset());
    //console.log(time);
  }
  return time;
}

GoogleCalendar.objects = new Object();

if (top.myBrowser.needsXMLHttpRequestVariable) {var XMLHttpRequest;}