var backWidth = 220;
var backHeight = 290;
var frontWidth = 320;
var frontHeight = 110;
var backShown = false;
var interval = null;
var alertTime = null;
var countdown = null;

var calUrl = null;
var calMode = false;

var testTime = false;
var widgetopUrl = "http://www.widgetop.com?add=";

function setup() {
  if (window.widget) {
    if (!widget.context) {
      document.getElementById("Widgetop").style.display = "block";
    }
    window.resizeTo(frontWidth, frontHeight);  
    widgetSetup();
    widget.onshow = show;
    widget.onhide = hide;
    widget.onremove = clearPrefs;
    
    $("SoundSelect").onchange = function() {
      var sound = $("SoundSelect").value;
      if (sound != null && sound.length > 0) {
        Countdown.playSound(sound);
      }
    }
    $("Header").onclick = function() {
      if (countdown.time.url) {
        widget.openURL(countdown.time.url);
      }
    }
    if (window.GoogleCalendar) {
      googleSetup();
    }
    else {
      timeSetup();
    }      
    readPrefs();
  }  
}

function timeSetup() {
  widgetopUrl += "AHectorCountdown";
  $("TimeSettings").style.display = "block";
  var newYear = new Date();
  if (testTime && location.protocol.indexOf("file") >= 0) {
    newYear.setMinutes(newYear.getMinutes() + 1);
  }
  else {  
    newYear.setMonth(0);
    newYear.setDate(1);
    newYear.setFullYear(newYear.getFullYear() + 1);
    newYear.setMinutes(0);
    newYear.setSeconds(0);
    newYear.setHours(0);
    newYear.setSeconds(0);
    newYear.setMilliseconds(0);
  }
  alertTime = new Time("New Year", newYear, 1);
  countdown = new Countdown(alertTime, $("InnerContent"), "");
  countdown.setLogo("clock.png");
  $("LogoUrl").value = "clock.png";

  DWRUtil.addOptions("MonthSelect", ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]);
  $("MonthSelect").onchange = fillDaySelect;
  
  $("MonthSelect").selectedIndex = 0;
  fillYearSelect();
  fillDaySelect();
  fillHourSelect(0);
  fillMinuteSelect(0);
  DWRUtil.addOptions("WeekSelect", ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"]);
  
  DWRUtil.addOptions("RepeatSelect", ["None", "Yearly", "Monthly", "Daily", "Weekly"]);
  $("RepeatSelect").onchange = repeatChanged;
  readTimePrefs();
}

function googleSetup() {  
  widgetopUrl += "AGoogleCountdown";
  $("Title").innerHTML = "Calendar Countdown"
  $("CalendarSettings").style.display = "block";
  $("FeedUrl").onchange = hideBack;
  calMode = true;
  alertTime = new GoogleCalendar();

  countdown = new Countdown(alertTime, $("InnerContent"), "");
  countdown.setLogo("calendar.png");
  $("LogoUrl").value = "calendar.png";
  countdown.onload = function() {
    show();
    $("UrlError").innerHTML = "";
  }
  countdown.onerror = function() {
    hide();
    showBack();
    $("UrlError").innerHTML = "Can't get calendar feed.";
  }

  readCalPrefs();
  if (calUrl != null) {
    $("FeedUrl").value = calUrl;
    reloadCalendar();
  }
  else {
    showBack();
  }  
}

function reloadCalendar() {
  alertTime.calUrl = calUrl;
  alertTime.useJson = true;
  alertTime.jsonElementId = "CalScript";
  alertTime.requestCalendar();
}

function readTimePrefs() {
  var value = widget.preferenceForKey(widget.identifier + "-time");
  if (value != null) {
    alertTime.time = new Date(parseInt(value));    
  }

  var value = widget.preferenceForKey(widget.identifier + "-repeat");
  if (value != null) {
    var repeat = parseInt(value);
    if (repeat >= 0  && repeat < $("RepeatSelect").length)
    alertTime.repeat = parseInt(value);    
  }
  selectTime();

  value = widget.preferenceForKey(widget.identifier + "-title");
  if (value != null) {
    countdown.setTitle(value);
  }
  $("HeaderText").value = countdown.time.title;

  value = widget.preferenceForKey(widget.identifier + "-url");
  if (value != null) {
    countdown.time.url = value;
  }
}

function readCalPrefs() {
  value = widget.preferenceForKey(widget.identifier + "-calUrl");
  if (value) {
    calUrl = value;
  }
  else {
    calUrl = "http://www.google.com/calendar/feeds/ht3jlfaac5lfd6263ulfh4tql8%40group.calendar.google.com/public/full";    
  }  
}

function readPrefs() {
  value = widget.preferenceForKey(widget.identifier + "-logo");
  if (value != null) {
    countdown.setLogo(value);
    var select = $("LogoUrl");
    var options = select.options;
    var found = false;
    for (var i = 0; i < options.length; i++) {
    	if (options[i].value == value) {
    	  select.value = value;
    	  found = true
    	  break;
    	}
    }
    if (!found) {
      var option = document.createElement("option");
      option.innerHTML = "Custom";
      option.value = value;
      select.add(option, null);
      select.value = value;
    }
  }
  
  value = widget.preferenceForKey(widget.identifier + "-sound");
  if (value != null) {
    countdown.alertSound = value;
    var select = $("SoundSelect");
    var options = select.options;
    var found = false;
    for (var i = 0; i < options.length; i++) {
    	if (options[i].value == value) {
    	  select.value = value;
    	  found = true
    	  break;
    	}
    }
    if (!found) {
      var option = document.createElement("option");
      option.innerHTML = "Custom";
      option.value = value;
      select.add(option, null);
      select.value = value;
    }
  }
}

function clearPrefs() {
  widget.setPreferenceForKey(null, widget.identifier + "-time");
  widget.setPreferenceForKey(null, widget.identifier + "-repeat");
  widget.setPreferenceForKey(null, widget.identifier + "-title");
  widget.setPreferenceForKey(null, widget.identifier + "-url");
  widget.setPreferenceForKey(null, widget.identifier + "-logo");
  widget.setPreferenceForKey(null, widget.identifier + "-calUrl");
  widget.setPreferenceForKey(null, widget.identifier + "-sound");
}

function show() {
  if (interval) {
    clearInterval(interval);
  }  
  interval = setInterval(function() {
    countdown.update(new Date());
  }, 200);
}

function hide() {
  if (interval) {
    clearInterval(interval);
    interval = null; 
  }  
}

function fillYearSelect() {
  var date = new Date();
  var select = $("YearSelect");
  DWRUtil.removeAllOptions(select);
  for (var i = date.getFullYear(); i <= date.getFullYear() + 5; i++) {
  	var option = document.createElement("option");
  	option.value = i;
  	option.innerHTML = i;  	  
  	select.appendChild(option);  
  }
  select.selectedIndex = 1;
}
    
function fillDaySelect() {
  var month = $("MonthSelect").selectedIndex;
  var select = $("DaySelect");
  var day = select.selectedIndex;
  DWRUtil.removeAllOptions(select);
  for (var i = 1; i <= countdown.daysInMonth[month]; i++) {
  	var option = document.createElement("option");
  	option.value = i;
  	option.innerHTML = i;  	  
  	select.appendChild(option);  
  }
  if (day < select.length) {
    select.selectedIndex = day;
  }
  else {
    select.selectedIndex = select.length - 1;
  }  
}
    
function fillHourSelect() {
  var select = $("HourSelect");
  DWRUtil.removeAllOptions(select);
  for (var i = 0; i <= 23; i++) {
  	var option = document.createElement("option");
  	option.value = i;
  	option.innerHTML = i;  	  
  	select.appendChild(option);  
  }
}
    
function fillMinuteSelect() {
  var select = $("MinuteSelect");
  DWRUtil.removeAllOptions(select);
  for (var i = 0; i <= 59; i++) {
  	var option = document.createElement("option");
  	option.value = i;
  	var text = i;
  	if (i < 10) {
  	  text = "0" + i;
  	}
  	option.innerHTML = text;  	  
  	select.appendChild(option);  
  }
}

function selectTime() {
  if (calMode) {
    
  }
  else {
    var time = countdown.time.getTime();
    $("YearSelect").value = time.getFullYear();
    $("MonthSelect").selectedIndex = time.getMonth();
    $("DaySelect").selectedIndex = time.getDate() - 1;
    $("HourSelect").selectedIndex = time.getHours();
    $("MinuteSelect").selectedIndex = time.getMinutes();
    $("WeekSelect").selectedIndex = time.getDay();
    
    $("RepeatSelect").selectedIndex = countdown.time.repeat;
    repeatChanged();
  }  
}

function repeatChanged() {
  var repeat = $("RepeatSelect").selectedIndex;
  if (repeat < 4) {
    $("Date").style.display = "block";
    $("Week").style.display = "none";
    $("YearSelect").disabled = repeat > 0 && repeat < 4;
    $("MonthSelect").disabled = repeat > 1 && repeat < 4;
    $("DaySelect").disabled = repeat > 2 && repeat < 4;
  }
  else {
    $("Date").style.display = "none";
    $("Week").style.display = "block";    
  }  
}

function updateTime() {
  if (calMode) {
    calUrl = $("FeedUrl").value;
    widget.setPreferenceForKey(calUrl, widget.identifier + "-calUrl");  
    reloadCalendar();
  }
  else {
    var repeat = $("RepeatSelect").selectedIndex;
    countdown.time.setRepeat(repeat);
  
    if (repeat < 4) {
      var date = new Date($("YearSelect").value, $("MonthSelect").selectedIndex, 
                          $("DaySelect").selectedIndex + 1, $("HourSelect").selectedIndex, $("MinuteSelect").selectedIndex);
    }
    else {
      var date = new Date();
      var diff = $("WeekSelect").selectedIndex - date.getDay();
      if (diff < 0) {
        diff += 7
      }
      date.setDate(date.getDate() + diff);
      date.setHours($("HourSelect").selectedIndex);
      date.setMinutes($("MinuteSelect").selectedIndex);
    }                      
    countdown.time.setTime(date);
    countdown.update(new Date());
    widget.setPreferenceForKey(date.getTime(), widget.identifier + "-time");  
    
    var title = $("HeaderText").value;
    countdown.setTitle(title);
    widget.setPreferenceForKey(title, widget.identifier + "-title");
  }
    
  var img = $("LogoUrl").value;
  if (img != null && img.length == 0) {
    img = null;
  }
  countdown.setLogo(img);
  
  var sound = $("SoundSelect").value;
  if (sound != null && sound.length == 0) {
    sound = null;
  }
  countdown.alertSound = sound;
  widget.setPreferenceForKey(sound, widget.identifier + "-sound");
}  

    
function widgetSetup() {
  if (window.widget) {
  	var gDoneButton = new AppleGlassButton(document.getElementById("DoneButton"), 
  	                                      "Done", hideBack); 
  	var gCloseButton = new AppleGlassButton(document.getElementById("AlertClose"), 
  	                                      "OK", function () {
  	                                        countdown.closeAlert()}); 
	  var gInfoButton = new AppleInfoButton(document.getElementById("InfoButton"), 
	                                        document.getElementById("front"), 
	                                        "white", "white", showBack);
	  //gInfoButton.setCircleOpacity(0.5);                                      
  }
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if(window.widget)
        widget.prepareForTransition("ToBack");
 
    selectTime();
    backShown = true;
    front.style.display="none";
    frontWidth = window.innerWidth;
    frontHeight = window.innerHeight;
    window.resizeTo(backWidth, backHeight);
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
     
    updateTime();
    backShown = false;
    back.style.display="none";
    window.resizeTo(frontWidth, frontHeight);  
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}                                                
  